package voip

import (
	"testing"
)

//TODO: add CSRCs[] test
func compareRtpHeader(packetA, packetB RtpPacket) bool {
	isEqual := true

	headerA := packetA.Header
	headerB := packetB.Header
	isEqual = headerA.Version == headerB.Version	&&
		headerA.Padding == headerB.Padding	&&
		headerA.Extension == headerB.Extension	&&
		headerA.CSRCCount == headerB.CSRCCount	&&
		headerA.Marker == headerB.Marker	&&
		headerA.PayloadType == headerB.PayloadType &&
		headerA.TimeStamp == headerB.TimeStamp	&&
		headerA.SSRC == headerB.SSRC		//&&
		//headerB.CSRCs == headerB.CSRCs
	return isEqual
}

func TestBuildNew(t *testing.T) {
	rawRtp := []byte {
		0x80, 0x00, 0x18, 0x65, 0x32, 0x4d, 0x45, 0x85,
		0x0c, 0x12, 0x4d, 0xf6, 0xff, 0x7f, 0xff, 0xff,
		0xff, 0xfe, 0xfe, 0x7e, 0x7e, 0xff, 0x7f, 0x7e,
		0x7d, 0x7b, 0x7d, 0xfe, 0xfd, 0x7e, 0xff, 0xfd,
		0xfe, 0xfe, 0xfd, 0xfe, 0xff, 0xfe, 0x7f, 0xff,
		0xfe, 0xfd, 0xfe, 0xfe, 0xfd, 0xfd, 0xfc, 0x7f,
		0x7d, 0x7d, 0x7e, 0xfe, 0xfe, 0xfe, 0xff, 0xfe,
		0xfe, 0xfe, 0x7d, 0x7c, 0x7c, 0x7d, 0x7b, 0x7a,
		0x7c, 0x7c, 0x7d, 0x7e, 0x7d, 0x7c, 0x7e, 0x7d,
		0x7e, 0xfd, 0xfe, 0x7d, 0x7d, 0xff, 0xfe, 0xfc,
		0xfd, 0xfc, 0xfa, 0xfc, 0xfd, 0xfd, 0xfd, 0xfe,
		0xfd, 0xfd, 0xfe, 0xff, 0xff, 0xfc, 0xfb, 0xfc,
		0xfd, 0x7e, 0x7c, 0x7c, 0x7d, 0xfe, 0xfd, 0xfd,
		0xfd, 0xfe, 0x7f, 0x7d, 0x7d, 0x7e, 0x7c, 0x7e,
		0xfe, 0xff, 0x7b, 0x79, 0x7d, 0x7c, 0x7c, 0x7e,
		0xfe, 0xfe, 0x7e, 0xfe, 0xfd, 0xfd, 0x7e, 0x7d,
		0xfe, 0xfd, 0x7d, 0xff, 0xfc, 0xfb, 0xfe, 0x7e,
		0xfc, 0xf8, 0xfb, 0xfc, 0xfc, 0xfd, 0xfb, 0xfb,
		0xfb, 0xf9, 0xf8, 0xfa, 0xf9, 0xf8, 0xf5, 0xf3,
		0xf4, 0xf6, 0xfb, 0xfb, 0xf8, 0xf5, 0xf5, 0xfc,
		0x7c, 0xfc, 0xf6, 0xf4, 0xf5, 0xf6, 0xf9, 0x7b,
		0x7c, 0xf6, 0xf1, 0xfb,
	}

	// Expected Value
	expectedRtp := RtpPacket{}
	expectedRtp.Header.Version = 2
	expectedRtp.Header.Padding = 0
	expectedRtp.Header.Extension = 0
	expectedRtp.Header.CSRCCount = 0
	expectedRtp.Header.Marker = 0
	expectedRtp.Header.PayloadType = 0
	expectedRtp.Header.Sequence = 6245
	expectedRtp.Header.TimeStamp = 843924869
	expectedRtp.Header.SSRC = 0x0c124df6
	//expectedRtp.Header.CSRCs = nil
	expectedRtp.Payload = []byte {
		0xff, 0x7f, 0xff, 0xff, 0xff, 0xfe, 0xfe, 0x7e,
		0x7e, 0xff, 0x7f, 0x7e, 0x7d, 0x7b, 0x7d, 0xfe,
		0xfd, 0x7e, 0xff, 0xfd, 0xfe, 0xfe, 0xfd, 0xfe,
		0xff, 0xfe, 0x7f, 0xff, 0xfe, 0xfd, 0xfe, 0xfe,
		0xfd, 0xfd, 0xfc, 0x7f, 0x7d, 0x7d, 0x7e, 0xfe,
		0xfe, 0xfe, 0xff, 0xfe, 0xfe, 0xfe, 0x7d, 0x7c,
		0x7c, 0x7d, 0x7b, 0x7a, 0x7c, 0x7c, 0x7d, 0x7e,
		0x7d, 0x7c, 0x7e, 0x7d, 0x7e, 0xfd, 0xfe, 0x7d,
		0x7d, 0xff, 0xfe, 0xfc, 0xfd, 0xfc, 0xfa, 0xfc,
		0xfd, 0xfd, 0xfd, 0xfe, 0xfd, 0xfd, 0xfe, 0xff,
		0xff, 0xfc, 0xfb, 0xfc, 0xfd, 0x7e, 0x7c, 0x7c,
		0x7d, 0xfe, 0xfd, 0xfd, 0xfd, 0xfe, 0x7f, 0x7d,
		0x7d, 0x7e, 0x7c, 0x7e, 0xfe, 0xff, 0x7b, 0x79,
		0x7d, 0x7c, 0x7c, 0x7e, 0xfe, 0xfe, 0x7e, 0xfe,
		0xfd, 0xfd, 0x7e, 0x7d, 0xfe, 0xfd, 0x7d, 0xff,
		0xfc, 0xfb, 0xfe, 0x7e, 0xfc, 0xf8, 0xfb, 0xfc,
		0xfc, 0xfd, 0xfb, 0xfb, 0xfb, 0xf9, 0xf8, 0xfa,
		0xf9, 0xf8, 0xf5, 0xf3, 0xf4, 0xf6, 0xfb, 0xfb,
		0xf8, 0xf5, 0xf5, 0xfc, 0x7c, 0xfc, 0xf6, 0xf4,
		0xf5, 0xf6, 0xf9, 0x7b, 0x7c, 0xf6, 0xf1, 0xfb,
	}

	// Actual Value
	actualRtp := RtpPacket{}
	actualRtp.BuildNew(rawRtp)

	if !compareRtpHeader(expectedRtp, actualRtp) {
		t.Errorf("Packet header dissection was incorrect")
	}
}
